;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; ColorChange
;
; COLORCHANGE nert die Farbe eines Layers durch Auswahl eines Elements,
; das die Farbe des Layers besitzt. Somit mu man nicht mehr umstndlich
; in der Layerliste nach einem bestimmten Layer suchen um dessen Farbe zu
; ndern, sondern whlt ein Element aus, das auf dem zu ndernden Layer
; liegt.
;
; Aufruf: colorchg
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; (c) Dipl.-Ing.  Volker Kleppel
; http://www.cadwerk.com
; vkleppel@gmx.de
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Version: 1.0                      Datum: 23.8.1999
; AutoCAD12   [ ]  AutoCAD14   [x]  AutoCAD2000(i) [x]   
; AutoCAD2002 [x]  AutoCAD2004 [x]  AutoCAD2005    [x]
; AutoCAD2006 [x]  AutoCAD2007 [x]  AutoCAD2008    [x]
; Freeware    [x]  Shareware   [ ]
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

(defun c:colorchg ( / temp dump exitflag en ent laEN clEN clLA)

	(setq enX (nentsel "\nElement mit Farbinformation whlen"))
	(if (/= enX nil)
		(progn
			(setq en    (car enX)
			      ent   (entget en)
			      laEN  (cdr (assoc 8 ent))
			      clEN  (cdr (assoc 62 ent))
					laENT (tblsearch "LAYER" laEN)
			      clLA  (cdr (assoc 62 laENT))
			)

			(if (/= clEN nil)			
			(if (AND (> clEN 0) (< clEN 256)) (setq exitflag T))
			)

			(if (= exitflag T)
				(progn
					(princ (strcat "\nDas Element reprsentiert nicht die Farbe des Layers " laEN))
					(princ "\nDeshalb wird an dieser Stelle abgebrochen")
				)
				(progn
					(princ (strcat "\nDie Farbe von Layer " laEN " wird gendert ..."))
					(setq dump (acad_colordlg clLA nil))
					(if (/= dump nil)
						(progn
							(command "-layer" "fa" dump laEN "")
							(princ "\nFarbe wurde gendert")
						)
						(princ "\nAbbruch - Farbe wurde nicht gendert!")
					)
				)
			)
		)
	)
	(print)
)

(princ "\nColorChange - (c) Dipl.-Ing. V. Kleppel, www.cadwerk.com")
(princ "\nAufruf: colorchg")
(print)